property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "MindReader"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://homepage.mac.com/jonn8/as/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:%20MindReader%20(v" & script_version & ")"
property script_contribution_url : "https://order.kagi.com/?ELJ"

property first_run : true
property run_plead : true
property the_match : missing value

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	my quit_prep()
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
		end tell
		my prep_game()
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & script_release_date)
				set contents of text field "copyright" to (script_copyright)
				set state of button "run_plead" to (run_plead as integer)
			end tell
		end tell
		
	end if
end awake from nib

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		my quit_prep()
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "contribute" then
		open location script_contribution_url
		
	else if object_name = "run_plead" then
		set run_plead to true
		if state of the_object = 0 then set run_plead to false
		my write_settings()
		
	else if object_name = "reveal" then
		set visible of the_object to false
		tell window "main"
			repeat with this_element in progress indicators
				tell (contents of this_element) to stop
			end repeat
			set contents of text field "the_match" to the_match
			set visible of button "again" to true
		end tell
		
	else if object_name = "again" then
		set visible of the_object to false
		my prep_game()
		
	end if
end clicked

on will open the_object
	try
		set {x, y} to (get size of window "main")
		set size of the_object to {x, y - 22}
	end try
	return true
end will open

on quit_prep()
	set panel_wins to name of (windows whose class = panel and visible = true)
	repeat with i from 1 to (length of panel_wins)
		try
			close panel window (item i of panel_wins)
		end try
	end repeat
	my write_settings()
	if run_plead then my plead()
	set quitting to true
end quit_prep

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"first_run", contents:first_run}
		make new default entry at end of default entries with properties {name:"run_plead", contents:run_plead}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set first_run to contents of default entry "first_run"
		set run_plead to contents of default entry "run_plead"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "first_run" to first_run
		set contents of default entry "run_plead" to run_plead
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status

on plead()
	activate
	if button returned of (display dialog "I hope you found this fun. If so, please consider contributing to my general development costs. (See the About box to disable this reminder.)" buttons {"Later", "OK"} default button 2 with icon 1) = "OK" then open location script_contribution_url
end plead

on make_the_grid()
	set the_characters to (characters of "ABCDEFGHIJKLMNOPQRSTUVWXYZ")
	set the_match to item (random number from 1 to (count the_characters)) of the_characters
	set the_number to 99
	set the_grid to {}
	repeat with i from 1 to 10
		set this_row to {}
		repeat with j from 1 to 10
			if the_number mod 9 = 0 then
				set l to the_match
			else
				repeat
					set l to item (random number from 1 to (count the_characters)) of the_characters
					if l  the_match then exit repeat
				end repeat
			end if
			set end of this_row to ("" & the_number & " = " & l)
			set the_number to the_number - 1
		end repeat
		set end of the_grid to this_row
	end repeat
	return the_grid
end make_the_grid

on prep_game()
	tell window "main"
		set contents of text field "the_match" to ""
		set visible of button "reveal" to true
		set visible of button "again" to false
		repeat with this_element in progress indicators
			tell (contents of this_element) to start
		end repeat
		tell data source of table view 1 of scroll view 1
			try
				delete data rows
			end try
			try
				delete data columns
			end try
			repeat with i from 1 to 10
				make new data column at end of data columns with properties {name:(i as Unicode text)}
			end repeat
			append with (my make_the_grid())
		end tell
	end tell
end prep_game
